#pragma once

#include <string>

extern "C"
{
	#include <libavformat/avformat.h>
}

class AudioDecoder
{
public:
	AudioDecoder();
	~AudioDecoder();

	bool decodeFile(std::string* filename);
	void close();
	float getSample(uint64_t sample, int channel);

	uint8_t* getSampleBuffer();
	uint64_t getBufferSize();
	uint64_t getNumSamples();
	int getSampleRate();
	int getNumChannels();
	double getDuration();
	bool getIsPlanar();
	bool getDidInit();
	AVSampleFormat getSampleFormat();

private:
	uint8_t* sampleBuffer = nullptr;
	uint64_t bufferSize = 0;
	uint64_t numSamples = 0;
	int sampleRate = 0;
	int numChannels = 0;
	double duration = 0;
	bool planar = false;
	bool didInit = false;
	AVSampleFormat sampleFormat = AV_SAMPLE_FMT_NONE;

	bool sampleBufferSet = false;
};

